//
// Created by Attila Haluska on 8/13/18.
//

#include "compiler/lexer/token.h"

#include <stddef.h>
#include <string.h>

#include "memory_management/memory.h"

bool token_is_double(const Token* token) {
    if (token != NULL) {
        for (int i = 0; i < token->length; i++) {
            char c = *(token->start + i);

            if (c == '.') {
                return true;
            }
        }
    }

    return false;
}

char* token_get_lexeme(const Token* token) {
    char* str = NEW_WITH_SIZE(char, token->length + 1);
    strncpy(str, token->start, token->length);
    str[token->length] = '\0';
    return str;
}

void token_free(Token* token) {
    if (token != NULL) {
        DELETE_TYPE(Token, token);
    }
}
